#!/bin/sh

DIRNAME=`busybox dirname "$0"`

if ! mount | grep "SYSjava"
then
    if [ ! -f "$DIRNAME"/kvm.orig ]
    then
		cp -ar /usr/SYSjava/kvm "$DIRNAME"/kvm.orig
		cp -ar /usr/SYSjava/fastjar "$DIRNAME"/
    fi
mount -o bind "$DIRNAME" /usr/SYSjava
exit
fi

constjava() {
APPTYPE=`grep -n "AppType = " "$INSTALLEDDB" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
ATTRIBUTE=`grep -n "Attribute = " "$INSTALLEDDB" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
BIGICON=`grep -n "BigIcon = " "$INSTALLEDDB" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
DAEMON=`grep -n "Daemon = " "$INSTALLEDDB" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
DIRECTORY=`grep -n "Directory = " "$INSTALLEDDB" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
EXECID=`grep -n "ExecId = " "$INSTALLEDDB" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
MIDLETICON=`grep "Icon = " "$INSTALLEDDB" | grep -v "AniIcon = " | grep -v "BigIcon = " | awk '{print $NF}' | sed -n "$MIDLETN"\p`
}

multijava() {
	constjava
	sed -i "$APPTYPE d" "$INSTALLEDDB"
	sed -i "$APPTYPE i\AppType = 0" "$INSTALLEDDB"
	sed -i "$ATTRIBUTE d" "$INSTALLEDDB"
	sed -i "$ATTRIBUTE i\Attribute = 3" "$INSTALLEDDB"
	sed -i "$BIGICON d" "$INSTALLEDDB"
	sed -i "$BIGICON i\BigIcon = $MIDLETDIR/Files/suiteicon_usr.png" "$INSTALLEDDB"
	sed -i "$DAEMON d" "$INSTALLEDDB"
	sed -i "$DAEMON i\Daemon = 1" "$INSTALLEDDB"
	sed -i "$DIRECTORY s@Directory = @Directory = ../..@" "$INSTALLEDDB"
	sed -i "$EXECID d" "$INSTALLEDDB"
	sed -i "$EXECID i\ExecId = java.sh" "$INSTALLEDDB"
	cp -ar "$MIDLETDIR"/"$MIDLETICON" "$MIDLETDIR"/Files/suiteicon_usr.png
	rm -fr "$MIDLETDIR"/"$MIDLETICON"
	echo -ne "#!/bin/sh
exec /usr/SYSjava/kvm -launch " >"$MIDLETDIR"/java.sh
	echo "$JAVAID" | sed s/^0*//g >>"$MIDLETDIR"/java.sh
}

unmultijava() {
	constjava
	JAVAID=`grep "-launch" "$MIDLETDIR"/java.sh | awk '{print $NF}'`
	ed -i "$APPTYPE d" "$INSTALLEDDB"
	sed -i "$APPTYPE i\AppType = 1" "$INSTALLEDDB"
	sed -i "$ATTRIBUTE d" "$INSTALLEDDB"
	sed -i "$ATTRIBUTE i\Attribute = 5" "$INSTALLEDDB"
	sed -i "$BIGICON d" "$INSTALLEDDB"
	sed -i "$BIGICON i\BigIcon = $MIDLETICON" "$INSTALLEDDB"
	sed -i "$DAEMON d" "$INSTALLEDDB"
	sed -i "$DAEMON i\Daemon = 0" "$INSTALLEDDB"
	sed -i "$DIRECTORY s@Directory = ../..@Directory = @" "$INSTALLEDDB"
	sed -i "$EXECID d" "$INSTALLEDDB"
	sed -i "$EXECID i\ExecId = $JAVAID" "$INSTALLEDDB"
	cp -ar "$MIDLETDIR"/Files/suiteicon_usr.png "$MIDLETDIR"/"$MIDLETICON"
	rm -fr "$MIDLETDIR"/Files/suiteicon_usr.png
	rm -fr "$MIDLETDIR"/java.sh
	showNotify "" "Изменения выполнены" 1 2
	/bin/kill `pidof am`
	exit
}

JAVAID=`echo $@ | awk '{print $NF}'`

if [ "$JAVAID" = "" ]
then
	showRadio "UnMultiJava" "" "Телефон" "Карта памяти"
RADIORES=$?
	if [ "$RADIORES" = "1" ]
	then
	INSTALLEDDB=/ezxlocal/download/appwrite/am/InstalledDB
	elif [ "$RADIORES" = "2" ]
	then
	INSTALLEDDB=/mmc/mmca1/.system/java/CardRegistry
	else
		exit
	fi
	showRadio "UnMultiJava" "" `for i in $(grep "ExecId = " $INSTALLEDDB | grep -n "ExecId = java.sh" | awk -F '[:]' '{print $1}');do
grep "Name = " "$INSTALLEDDB" | sed -e "s/Name = //" -e "s/\ /_/g" | sed -n "$i"\p | awk '{print $NF}'
done`
MIDLETN=$?
	if [ "$MIDLETN" = "0" ]
	then
		exit
	else
	MIDLETN=`grep "ExecId = " $INSTALLEDDB | grep -n "ExecId = java.sh" | awk -F '[:]' '{print $1}' | sed -n "$MIDLETN"\p`
	MIDLETDIR=`grep "Directory = " "$INSTALLEDDB" | awk '{print $NF}' | sed -n "$MIDLETN"\p | sed s@../..@@`
	unmultijava
	fi
fi

if [ "$JAVAID" -lt "20000" ]
then
JAVAID="00$JAVAID"
INSTALLEDDB=/ezxlocal/download/appwrite/am/InstalledDB
else
INSTALLEDDB=/mmc/mmca1/.system/java/CardRegistry
fi

MIDLETDIR=`grep "Directory = " $INSTALLEDDB | grep "MIDlet$JAVAID" | awk '{print $NF}'`
MIDLETSS=`find "$MIDLETDIR"/Files -name *.ss`
MIDLETII=`find "$MIDLETDIR"/Files -name *.ii`
    cp -ar "$DIRNAME"/java.ss "$MIDLETSS"
    cp -ar "$DIRNAME"/java.ii "$MIDLETII"

if [ ! -f "$MIDLETDIR"/java.sh ]
then
	showRadio "MultiJava" "Следующий запуск" "Да" "Спросить"
RADIORES=$?
    touch "$MIDLETDIR"/java.sh
	if [ "$RADIORES" = "1" ]
	then
	MIDLETN=`grep "Directory = " $INSTALLEDDB | grep -n "MIDlet$JAVAID" | awk -F '[:]' '{print $1}'`
		multijava
		showNotify "" "Изменения вступят в силу после перезагрузки телефона или am" 1 2
	elif [ "$RADIORES" = "2" ]
	then
		rm -fr "$MIDLETDIR"/java.sh
	fi
else
		export LD_PRELOAD="$DIRNAME"/jaidaid.so
fi
	exec /usr/SYSjava/kvm.orig -launch $JAVAID
